unit spcommon;
{tato cast obsahuje spolecne casti pro spefo}
                                                   { 1. 5. 1989}
{$N+}
{$E-}
{$F+}

interface

uses Crt,Graph,Dos;
const
    Yes:char='Y';
    No :char='N';
    ln10:extended=2.30258509;
    loge:extended=0.43429448;

    lightvelocity=299792.0;

    Enter=13;
    Esc=27;
    Left=1075;
    Right=1077;
    ShiftRight=54;
    ShiftLeft=52;
    Up=1072;
    Down=1080;
    ShiftUp=56;
    ShiftDown=50;
    PgUp=1073;
    PgDn=1081;
    Home=1071;
    Endkey=1079;
    Plus=43;
    Minus=45;
    Ins=1082;
    Del=1083;

    KeyA=65;
    KeyC=67;
    KeyD=68;
    KeyF=70;
    KeyG=71;
    KeyL=74;
    KeyK=75;
    KeyM=77;
    KeyO=79;
    KeyP=80;
    KeyR=82;
    KeyS=83;
    KeyT=84;
    KeyV=86;
    KeyX=88;

    maxklin:integer=12;

type
    vector =array[0..6] of extended;
    matrix =array[1..6,1..7] of extended;
var
    a :matrix;
    B:array[0..10] of extended;
    LBK:array[0..5] of extended;
    grd,grm:integer;
    i,j:integer;
    readchar:char;
    dax,day:extended;
    dbx,dby:integer;

    calcoef:vector;
    trmin,trmax,trbmin:real;
    logint:array[1..12] of real;
    lginame:string[12];
    callimit,foglimit:array[1..30] of longint;
    ncl,nfl,nfog,nstep,nchange:integer;

    readval:integer;
    tbc1,tbc2,tbc3,txtc:integer;

    light,dark:array[1..5] of integer;
    xfrom,yfrom,xto,yto:longint;
    filename:string[25];
    platename,calname:string[12];
    dirname:pathstr;

    remark:string[30];
    usedcal:string[8];
    mintr:extended;
    dispcoef:vector;
    dispdegree:integer;
    starstep,fogstep,compstep,calstep:integer;

    difi,maxdifi,lefti,righti,firstread,lastread:longint;
    diline,dline,ndat:longint;
    mark:integer;
    changed,markchange:boolean;
    ddi,ddimin:longint;
    dr,kr,dbxr:extended;

procedure HiText(x,y:integer; s:string);
procedure LoText(x,y:integer; s:string);
function KeyRead:integer;
procedure PressAnyKey(i,x,y:integer);
procedure LinEqSol(var a:matrix;n:integer);
function Polynomial(var a:vector;n:integer;x:extended):extended;
procedure Head(x1,y1,x2,y2,bc,tc,k:integer);
procedure CrtMode;
procedure GraphMode(grm:integer);
function Baker(tr:real):extended;
function Xcoord(b:extended):integer;
function Ycoord(b:extended):integer;
procedure Arrow(x,y,d,k:integer);
function PolyDeriv(var a:vector;n:integer;x:extended):extended;
function RootofPoly(var a:vector;n:integer;y,x0,prec:extended):extended;
function Hexa(n:longint):string;
function SelectFile(x1,y1,x2,y2:integer;fln:string):string;
function YesNo:char;
procedure DeleteLine(c,l:integer);
function UpCases(s:string):string;

{-------------------------------------------------------------------------}


implementation


{------------------------------------------}
procedure HiText(x,y:integer; s:string);
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

begin
    TextBackground(tbc3);GotoXY(x,y);write(s);TextBackground(tbc2);
end;

{------------------------------------------}
procedure LoText(x,y:integer; s:string);
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

begin
    TextBackground(tbc2);GotoXY(x,y);write(s);
end;


{------------------------------------------}
function KeyRead:integer;
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
  var
    ch:char;
    ich:integer;
  begin
    ch:=UpCase(ReadKey);ich:=Ord(ch);
    if ich=0 then ich:=1000+Ord(readkey);
    KeyRead:=ich;
  end;

{------------------------------------------}
procedure PressAnyKey(i,x,y:integer);
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
  const
    s:string[27]='press any key';

  begin
    case i of
      0 : begin
            GoToXY(x,y);write(s);
          end;
      1 : OutTextXY(x,y,s);
    end;
    while not KeyPressed do ;    while not Ord(ReadKey)=0 do ;
  end;


{------------------------------------------------------------}
procedure LinEqSol(var a:matrix;n:integer);
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
  {procedure for solution of a system of linear equations}
  {n...number of equations;  a...matrix of coefficients:[1..n,1..n+1]}
  {right hand side coef  .. a[i,n+1]}
  {matrix a[n,n+1] must be typed in calling routine}
  var
    row,row0,col : integer;
    b            : extended;
  begin
    for row0:=1 to n do
    begin
      b:=1/a[row0,row0];for col:=row0+1 to n+1 do a[row0,col]:=a[row0,col]*b;
      if row0<n then
        for row:=row0+1 to n do
          for col:=row0+1 to n+1  do
            a[row,col]:=a[row,col]-a[row,row0]*a[row0,col];
    end;
    for row0:=n downto 2 do
      for row:=row0-1 downto 1 do
        a[row,n+1]:=a[row,n+1]-a[row,row0]*a[row0,n+1];
  end; {of procedure LinEqSol}
  {results of the solution are on a[i,n+1]}


{-------------------------------------------------------}
function Polynomial(var a:vector;n:integer;x:extended):extended;
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
      {computes value of polynomial of the order n}
      {coefficients are a[0..n] .... a[0] absolute}
  var
    p: extended;
    i:integer;
  begin        {of function Polynomial}
    p:=a[n];
    for i:=n-1 downto 0 do p:=p*x+a[i];
    Polynomial:=p;
  end;         {of function}

{--------------------------------------------------------}
procedure Head(x1,y1,x2,y2,bc,tc,k:integer);
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

  const
    luc:array[1..2]of char=(chr(218),chr(201));
    ruc:array[1..2]of char=(chr(191),chr(187));
    ldc:array[1..2]of char=(chr(192),chr(200));
    rdc:array[1..2]of char=(chr(217),chr(188));
    hl :array[1..2]of char=(chr(196),chr(205));
    vl :array[1..2]of char=(chr(179),chr(186));
  var
    i,j:integer;
  begin
    TextBackground(bc);TextColor(tc);Window(x1,y1,x2,y2+1);
    GotoXY(1,1);
    write(luc[k]);for i:=x1+1 to x2-1 do write(hl[k]);write(ruc[k]);
    for j:=y1+1 to y2-1 do begin
      write(vl[k]);for i:=x1+1 to x2-1 do write(' ');write(vl[k]);end;
    write(ldc[k]);for i:=x1+1 to x2-1 do write(hl[k]);write(rdc[k]);
  end;


{--------------------------------------------------------------------------}

procedure CrtMode;
{xxxxxxxxxxxxxxxxxxxxxxxxxx}
  begin
    RestoreCrtMode;DirectVideo:=true;
  end;

{--------------------------------------------------------------------------}

procedure GraphMode(grm:integer);
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
  begin
    SetGraphMode(grm);DirectVideo:=false;
  end;

{------------------------------------------------------------------------}

  function Baker(tr:real):extended;
  {xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
    begin
      Baker:=loge*ln((1-tr)/tr);
    end;          {funkce Baker}
  {---------------------------------------------------------------}
  {---------------------------------------------------------------}



{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
    function Xcoord(b:extended):integer;
      begin
        Xcoord:=Round(dax*b)+dbx;
      end;
    function Ycoord(b:extended):integer;
      begin
        Ycoord:=Round(day*b)+dby;
      end;

{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

procedure Arrow(x,y,d,k:integer);
{==================================}
{kresli sipky:   x,y souradnice spicky;   d delka
	 k=1 Left
	   2 Right
	   3 Up
	   4 Down}
  const
    kx:array[1..4] of integer=(1,-1,0,0);
    ky:array[1..4] of integer=(0,0,1,-1);
  var
    d1,d2:integer;
  begin
    d1:=Round(0.3*d);d2:=Round(0.12*d);
    Line(x+kx[k]*d,y+ky[k]*d,x,y);
    Line(x+kx[k]*d1+ky[k]*d2,y+ky[k]*d1+kx[k]*d2,x,y);
    Line(x+kx[k]*d1-ky[k]*d2,y+ky[k]*d1-kx[k]*d2,x,y);
  end;

{-------------------------------------------------------------------------}

function PolyDeriv(var a:vector;n:integer;x:extended):extended;
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
  var der:extended;
      i:integer;
  begin
    der:=n*a[n];
    for i:=n-1 downto 1 do der:=der*x+i*a[i];
    PolyDeriv:=der;
  end;

{--------------------------------------------------------------------------}

function RootofPoly(var a:vector;n:integer;y,x0,prec:extended):extended;
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
  var y0,x1,y1,p:extended;
  begin
    if n=1 then x0:=(y-a[0])/a[1]
      else
      repeat
        y0:=Polynomial(a,n,x0);x1:=x0+(y-y0)/PolyDeriv(a,n,x0);
        p:=a[n];
        for i:=n-1 downto 0 do p:=p*x1+a[i];
        if Abs(x1-x0)>=prec then begin
          y1:=p;x0:=x1+(y-y1)*(x0-x1)/(y0-y1);end;
      until Abs(x1-x0)<prec;
    RootofPoly:=x0;
  end;

{--------------------------------------------------------------------------}
{------------------------------------------------------------------------}
function Hexa(n:longint):string;
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
var i:integer;
    k:longint;
    s:string[8];
    t:string[2];
begin
  k:=1;if n>=0 then s:='$' else s:='-$';n:=Abs(n);
  while n>=(k shl 4) do k:=k shl 4;
  repeat
    i:=n div k;
    if i<10 then Str(i:1,t) else t:=Chr(55+i); s:=s+t;
    Dec(n,i*k);k:=k shr 4;
  until k<=0;
  Hexa:=s;
end;

{-------------------------------------------------------------------------}
{-------------------------------------------------------------------------}
{------------------------------------------------------------------------}
function SelectFile(x1,y1,x2,y2:integer;fln:string):string;
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

var i,j,k,k1,n,n1,nmax,nfile,ntot,nhigh,nsp:integer;
    xsize,col,row:integer;
    changed:boolean;
    fname:array[1..250] of string[12];
    Dir:dirStr;
    name:namestr;
    ext:extStr;
    S:SearchRec;
    return:boolean;
    fd:string[4];

function fn(k:integer):string;
  begin
    fn:=fname[k];if k>nfile then fn:=fname[k]+'\';
  end;

begin
  xsize:=x2-x1-1;col:=xsize div 12;nsp:=(xsize-12*col) div (col+1);
  xsize:=col*(nsp+12)+nsp;x2:=x1+xsize+1;
  row:=y2-y1-5;
  GetDir(0,dir);

  repeat

  n:=0;nfile:=0;return:=true;
  if fln<>'\' then begin
    FindFirst(fln,AnyFile,S);
    while DosError=0 do begin
      if S.Attr<>Directory then begin
      Inc(n);fname[n]:=S.name;end;
      FindNext(S);end;
    nfile:=n;FSplit(FExpand(S.name),dir,name,ext);
    end;

    FindFirst('*.*',Directory,S);
    while DosError=0 do begin
      if ((S.Attr=Directory) and ((S.name<>'.') or (fln='\'))) then begin
      Inc(n);fname[n]:=S.name;end;
      FindNext(S);end;
    ntot:=n;

    n1:=1;nhigh:=1;changed:=true;
    if fln='\' then begin GetDir(0,dir);fd:='dir ';end else fd:='file';

    repeat
      if changed then begin
        Head(x1,y1,x2,y2,tbc2,txtc,1);Window(x1,y1+1,x2,y2-1);
        HiText(3,1,'Current dir : ');
        HiText(3,2,Dir);
        GotoXY(3,3);write('Esc: select no '+fd);
        GotoXY(3,4);write('Del: change drive');
        if n>0 then begin
          nmax:=n1+col*row-1;if nmax>n then nmax:=n;
          for k1:=1 to n do begin
            k:=k1-n1;j:=(k div col) + 1;i:=k mod col+1;
            if k1 in [n1..nmax] then LoText((12+nsp)*i-10,j+4,fn(k1));
            end;
          HiText((nsp+12)*((nhigh-n1) mod col+1)-10,((nhigh-n1) div col)+5,
                 fn(nhigh));
          end else begin
          GotoXY(3,5);write('no file '''+fln+'''exists');
          SelectFile:='';exit;end;
        end;


        k:=KeyRead;changed:=false;
        case k of
          Right,Down : begin
              j:=1;if k=Down then j:=col;
              if nhigh<=nmax-j then begin
                LoText((nsp+12)*((nhigh-n1) mod col+1)-10,
                       ((nhigh-n1) div col)+5,fn(nhigh));
                Inc(nhigh,j);
                HiText((nsp+12)*((nhigh-n1) mod col+1)-10,
                       ((nhigh-n1) div col)+5,fn(nhigh));end
                else if nmax<n then begin
                  Inc(nhigh,j);if nhigh>n then nhigh:=n;
                  Inc(nmax,j);if nmax>n then nmax:=n;n1:=nmax-col*row+1;
                  changed:=true;end;
              end;
          Left,Up : begin
              j:=1;if k=Up then j:=col;
              if nhigh>=n1+j then begin
                LoText((nsp+12)*((nhigh-n1) mod col+1)-10,
                       ((nhigh-n1) div col)+5,fn(nhigh));
                Dec(nhigh,j);
                HiText((nsp+12)*((nhigh-n1) mod col+1)-10,
                       ((nhigh-n1) div col)+5,fn(nhigh));end
                else if n1>1 then begin
                  Dec(n1,j);if n1<1 then n1:=1;
                  Dec(nhigh,j);if nhigh<n1 then nhigh:=n1;
                  changed:=true;end;
              end;
          Home : if n1=1 then begin
                   LoText((nsp+12)*((nhigh-n1) mod col+1)-10,
                          ((nhigh-n1) div col)+5,fn(nhigh));
                   nhigh:=1;
                   HiText((nsp+12)*((nhigh-n1) mod col+1)-10,
                          ((nhigh-n1) div col)+5,fn(nhigh));end
                   else begin
                   n1:=1;changed:=true;nhigh:=1;end;
          EndKey : if nmax=n then begin
                     LoText((nsp+12)*((nhigh-n1) mod col+1)-10,
                            ((nhigh-n1) div col)+5,fn(nhigh));
                     nhigh:=nmax;
                     HiText((nsp+12)*((nhigh-n1) mod col+1)-10,
                            ((nhigh-n1) div col)+5,fn(nhigh));end
                     else begin
                     nmax:=n;changed:=true;nhigh:=n;
                     n1:=nmax-col*row+1;end;
          PgUp : begin Dec(n1,col*row);if n1<1 then n1:=1;
                   nhigh:=n1;changed:=true;end;
          PgDn : begin Inc(nmax,col*row);if nmax>n then nmax:=n;
                   n1:=nmax-col*row+1;if n1<1 then n1:=1;
                   nhigh:=nmax;changed:=true;end;
          Del  : LoText((nsp+12)*((nhigh-n1) mod col+1)-10,
                            ((nhigh-n1) div col)+5,fn(nhigh));
          end;
    until (k=Enter) or (k=Esc) or (k=Del);

    case k of
      Esc : begin
        LoText((nsp+12)*((nhigh-n1) mod col+1)-10,
               ((nhigh-n1) div col)+5,fn(nhigh));
        TextBackground(tbc2);SelectFile:='';
        HiText(3,3,'Esc = no file selected');
        end;
      Enter : begin
        if ((nhigh<=nfile) or (fname[nhigh]='.'))
        then SelectFile:=fname[nhigh]
        else begin
          ChDir(fname[nhigh]);return:=false;
          end;
        end;
      Del : begin
        Hitext(3,4,'Del - new drive : ');
        dir:=UpCase(ReadKey);
        dir:=dir+':';ChDir(dir);return:=false;end;
    end;
    until return;

  end;   {procedury}


{--------------------------------------------------------------------------}
{--------------------------------------------------------------------------}
function YesNo:char;
{xxxxxxxxxxxxxxxxxxxxx}
var ch:char;
begin
  repeat ch:=UpCase(ReadKey); until ch in [Yes,No];
  YesNo:=ch;
end;
{-------------------------------------------------------------------------}
procedure DeleteLine(c,l:integer);
{xxxxxxxxxxxxxxxxxxxxxxxx}
begin
  GotoXY(c,l);TextColor(black);DelLine;TextColor(txtc);GotoXY(c,l);
end;
{-------------------------------------------------------------------------}
function UpCases(s:string):string;
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
var s1:string[30];
    i:integer;
begin
    for i:=1 to Length(s) do s1[i]:=UpCase(s[i]);
    s1[0]:=s[0];
    UpCases:=s1;
end;
{-------------------------------------------------------------------------}


begin
  for i:=0 to 4 do calcoef[i]:=0.0;

end.